
set echo on

CREATE TABLE customers
( customer_id   NUMBER PRIMARY KEY
, first_name    VARCHAR2(30)
, last_name     VARCHAR2(50)
, start_date    DATE
);

CREATE TYPE customer_ot AS OBJECT
( customer_id   NUMBER
, first_name    VARCHAR2(30)
, last_name     VARCHAR2(50)
, start_date    DATE
, MEMBER FUNCTION print_key RETURN VARCHAR2
);
/

CREATE TYPE BODY customer_ot AS
   MEMBER FUNCTION print_key RETURN VARCHAR2 IS
   BEGIN
      RETURN TO_CHAR(SELF.customer_id);
   END;
END;
/

CREATE TYPE customer_ntt AS TABLE OF customer_ot;
/

