
set echo on

CREATE TYPE bulk_load_ot AS OBJECT
( generic_id NUMBER
, MEMBER FUNCTION print_key RETURN VARCHAR2
) NOT FINAL NOT INSTANTIABLE;
/

CREATE TYPE BODY bulk_load_ot AS
   MEMBER FUNCTION print_key RETURN VARCHAR2 IS
   BEGIN
      RETURN TO_CHAR(SELF.generic_id);
   END;
END;
/

CREATE TYPE bulk_load_ntt AS TABLE OF bulk_load_ot;
/


